#include <stdio.h>

#define	ROUND_MASK	0xfff

unsigned long round_up(val)
unsigned long	val;
{
	val |= ROUND_MASK;
	return val+1;
}

unsigned long round_down(val)
unsigned long	val;
{
	return val & ~ROUND_MASK;
}

int stack_grows_up(older_frame_addr)
unsigned long older_frame_addr;
{
	unsigned long	this_frame_addr = (unsigned long) &this_frame_addr;

	return this_frame_addr > older_frame_addr;
}

main(ac,av,ev)
int	ac;
char	**av,**ev;
{
	char	*null_environ[] = { 0 };
	int	up = stack_grows_up((unsigned long) &ev);
	if (*ev) {
		execve(av[0],av,null_environ);
		fprintf(stderr,"EXEC ERROR\n");
		exit(1);
	}
	printf("The top of stack value printed by this program is derived using heuristics\nIf your system has the symbol USRSTACK defined in the header files\n<sys/param.h> or <sys/vmparam.h>,\ndo not use the output of this program.\n\nThe top of your stack is around 0x%lx; the stack grows %s\nTry 0x%lx\n",(unsigned long) &ev,up?"up":"down",up?round_down((unsigned long) &ev):round_up((unsigned long) &ev));
	exit(0);
}
